<?php

include "freemed_yirc-vars.inc";
include "freemed_yirc-funcs.inc";

fy_cookiecheck($cookie_user);
fy_resetcookie($cookie_user, $cookie_id, $fy_cookietime);

# Check out $cookie_id with the secdb.  Make sure 'ir_edit' = 'X'.
$conn=fy_makeconn($fydb_type, $fydb_host, $fydb_user, $fydb_name);
$sql = "SELECT * FROM fy_secdb WHERE loginid = '$cookie_id'";
$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);
$rows=fy_resultrows($fydb_type, $result_set);

if ($rows > 0)
{
	$perm=fy_getfield($fydb_type, $result_set, 0, "ir_edit");
} else {
	$perm = " ";
}

if ($perm != "X")
{
	fy_starthtml("Freemed-Yirc: Error","");
	fy_startwindow();
	fy_winprn("CENTER","","I'm sorry, but you don't have permission to edit the Incident Report database.");
	fy_winback("","main.php");
	fy_endwindow("User: $cookie_user");
	fy_endhtml();
	exit;
}

fy_starthtml("Freemed-Yirc: Verifying Entered Data","");
fy_startwindow();
fy_winprn("CENTER","","Verifying Entered Data...");

# ======= VERIFY USER ENTERED DATA =======

# Reset EXITFLAG
$ef=0;


# Incident Date
if (!checkdate($gr_incidentdate_m, $gr_incidentdate_d, $gr_incidentdate_y))
{
	fy_winprn("CENTER","","<B>ERROR:</B> Invalid Date entered in '<I>Incident Date</I>'");
	$ef=1;
}

# Incident Date/Future....
if (!$ef)
{
	if (fy_isfuture($gr_incidentdate_m,$gr_incidentdate_d,$gr_incidentdate_y))
	{
		fy_winprn("CENTER","","<B>ERROR:</B> Invalid Date entered in '<I>Incident Date</I>'");
		fy_winprn("CENTER","","Date cannot be in the future.");
		$ef=1;
	}
}

# Incident Time (Hour)
if ($gr_incidenttime_h > 12 or $gr_incidenttime_h =="")
{
	fy_winprn("CENTER","","<B>ERROR:</B> Invalid Hour entered in '<I>Incident Time</I>'");
	fy_winprn("CENTER","","Should be 1-12");
	$ef=1;
}

# Incident End Time (Hour)
if ($gr_incidenttime_e_h > 12 or $gr_incidenttime_e_h =="")
{
	fy_winprn("CENTER","","<B>ERROR:</B> Invalid Hour entered in '<I>Incident End Time</I>'");
	fy_winprn("CENTER","","Should be 1-12");
	$ef=1;
}

# Incident Time (Minute)
if ($gr_incidenttime_m > 60 or $gr_incidenttime_m =="")
{
	fy_winprn("CENTER","","<B>ERROR:</B> Invalid Minute entered in '<I>Incident Time</I>'");
	fy_winprn("CENTER","","Should be 1-60");
	$ef=1;
}
if ($gr_incidenttime_ap == "PM" AND $gr_incidenttime_h < 12)
{
	$gr_incidenttime_h = $gr_incidenttime_h + 12;
}
if ($gr_incidenttime_ap == "AM" AND $gr_incidenttime_h == 12)
{
	$gr_incidenttime_h = 0;
}

# Incident End Time (Minute)
if ($gr_incidenttime_e_m > 60 or $gr_incidenttime_e_m =="")
{
	fy_winprn("CENTER","","<B>ERROR:</B> Invalid Minute entered in '<I>Incident End Time</I>'");
	fy_winprn("CENTER","","Should be 1-60");
	$ef=1;
}
if ($gr_incidenttime_e_ap == "PM" AND $gr_incidenttime_e_h < 12)
{
	$gr_incidenttime_e_h = $gr_incidenttime_e_h + 12;
}
if ($gr_incidenttime_e_ap == "AM" AND $gr_incidenttime_e_h == 12)
{
	$gr_incidenttime_e_h = 0;
}

# Incident End Time is AFTER Incident Time...
$temp_er=0;
if ($gr_incidenttime_e_ap == $gr_incidenttime_ap)
{
	if ($gr_incidenttime_e_h < $gr_incidenttime_h)
	{
		$temp_er=1;
	}
	if ($gr_incidenttime_e_h == $gr_incidenttime_h)
	{
		if ($gr_incidenttime_e_m < $gr_incidenttime_m)
		{
			$temp_er=1;
		}
	}
}

if ($temp_er == 1)
{
	fy_winprn("CENTER","","<B>ERROR:</B> Invalid Time entered in '<I>Incident End Time</I>'");
	fy_winprn("CENTER","","Should be <I>AFTER</I> Incident Time!");
	$ef=1;
}

# Incident Address
if ($gr_atgrouphome == "X")
{
	$gr_incidentaddress = $gr_grouphome;
} else {
	$gr_incidentaddress = ucwords(strtolower($gr_incidentaddress));
}

# Spell Check 'Remarks Summary'
$fy_spell2 = STRTOLOWER($fy_spell);
if ($fy_spell2 == "enable" AND $gr_remarkssummary
<> "")
{
	$noe=fy_spellcheck($gr_remarkssummary);

	if ($noe > 0)
	{
		fy_winprn("CENTER","","<B>WARNING:</B> $noe spelling error(s) found in  '<I>Remarks-Summary</I>'!");
	}
}

# Spell Check 'Action Taken'
$fy_spell2 = STRTOLOWER($fy_spell);
if ($fy_spell2 == "enable" AND  $gr_actiontaken <> "")
{
	$noe=fy_spellcheck($gr_actiontaken);

	if ($noe > 0)
	{
		fy_winprn("CENTER","","<B>WARNING:</B> $noe spelling error(s) found in  '<I>Action Taken</I>'!");
	}
}

# Spell Check 'Other Remarks'
$fy_spell2 = STRTOLOWER($fy_spell);
if ($fy_spell2 == "enable" AND $gr_otherremarks <> "")
{
	$noe=fy_spellcheck($gr_otherremarks);

	if ($noe > 0)
	{
		fy_winprn("CENTER","","<B>WARNING:</B> $noe spelling error(s) found in  '<I>Other Remarks</I>'!");
	}
}

# If 'Temper Tantrum' was not specified, then MAKE SURE that all the
# temper tantrum sub categories are blank!!!
if ($gr_tempertantrum == "")
{
	$gr_pretantrum = "";
	$gr_staffsupportive = "";
	$gr_interpersonal = "";
	$gr_staffdirective = "";
	$gr_eitheror = "";
	$gr_staffmaint = "";
	$gr_defiantstage = "";
	$gr_helpedres = "";
	$gr_aggression = "";
	$gr_staffintervention = "";
	$gr_posttantrum = "";
	$gr_stafftaught = "";
	$gr_ttother = "";
	$gr_critical = "";
}

# If 'Needed PCI' was not specified, then MAKE SURE that all the
# PCI sub categories are blank!!!
if ($gr_neededpci == "")
{
	$gr_anxietystage = "";
	$gr_youthdef = "";
	$gr_aop = "";
	$gr_tension = "";
	$gr_pciother = "";
	$gr_defensivelevel = 0;
	$gr_lor = 0;
}

# OTHERS INVOLVED
# We gotta lotta work to do here.  There are many ways to enter 'faulty' 
# data here, and we gotta check for ALL OF EM.
# If othinv1_ok was not checked, then blank out othinv1
if ($gr_othinv1_ok == "") {$gr_othinv1="";}
# If othinv2_ok was not checked, then blank out othinv2
if ($gr_othinv2_ok == "") {$gr_othinv2="";}
# If othinv3_ok was not checked, then blank out othinv3
if ($gr_othinv3_ok == "") {$gr_othinv3="";}
# If othinv1_ok was not specified but othinv2_ok was, then error!
if ($gr_othinv1_ok != "X" AND $gr_othinv2_ok == "X")
{
	fy_winprn("CENTER","","<B>ERROR:</B> You have a second person involved in '<I>Oth. Inv. 2</I>'");
	fy_winprn("CENTER","","But you have no first person involved...");
	$ef=1;
}
# If othinv1_ok was not specified but othinv3_ok was, then error!
if ($gr_othinv1_ok != "X" AND $gr_othinv3_ok == "X")
{
	fy_winprn("CENTER","","<B>ERROR:</B> You have a third person involved in '<I>Oth. Inv. 3</I>'");
	fy_winprn("CENTER","","But you have no first person involved...");
	$ef=1;
}
# If othinv1_ok was specified, othinv2_ok was not, but othinv3_ok was, error!
if ($gr_othinv1_ok == "X" AND $gr_othinv2_ok != "X" AND $gr_othinv3_ok == "X")
{
	fy_winprn("CENTER","","<B>ERROR:</B> You have a third person involved in '<I>Oth. Inv. 3</I>'");
	fy_winprn("CENTER","","But you have no second person involved...");
	$ef=1;
}
# Lets make sure that othinv1 isn't the same as our resident!
if ($gr_resident == $gr_othinv1)
{
	fy_winprn("CENTER","","<B>ERROR:</B> Your '<I>Oth. Inv. 1</I>' cannot be the");
	fy_winprn("CENTER","","same as your resident!!!");
	$ef=1;
}
# Lets make sure that othinv2 isn't the same as our resident!
if ($gr_resident == $gr_othinv2)
{
	fy_winprn("CENTER","","<B>ERROR:</B> Your '<I>Oth. Inv. 2</I>' cannot be the");
	fy_winprn("CENTER","","same as your resident!!!");
	$ef=1;
}
# Lets make sure that othinv3 isn't the same as our resident!
if ($gr_resident == $gr_othinv3)
{
	fy_winprn("CENTER","","<B>ERROR:</B> Your '<I>Oth. Inv. 3</I>' cannot be the");
	fy_winprn("CENTER","","same as your resident!!!");
	$ef=1;
}
# Lets make sure that othinv1 isn't the same as othinv2!!!
if (($gr_othinv1 == $gr_othinv2) AND ($gr_othinv1 != ""))
{
	fy_winprn("CENTER","","<B>ERROR:</B> Your '<I>Oth. Inv. 1</I>' and '<I>Oth. Inv. 2</I>'");
	fy_winprn("CENTER","","cannot be the same!!!");
	$ef=1;
}
# Lets make sure that othinv1 isn't the same as othinv3!!!
if ($gr_othinv1 == $gr_othinv3 AND ($gr_othinv3 != ""))
{
	fy_winprn("CENTER","","<B>ERROR:</B> Your '<I>Oth. Inv. 1</I>' and '<I>Oth. Inv. 3</I>'");
	fy_winprn("CENTER","","cannot be the same!!!");
	$ef=1;
}
# Lets make sure that othinv2 isn't the same as othinv3!!!
if ($gr_othinv2 == $gr_othinv3 AND ($gr_othinv2 != ""))
{
	fy_winprn("CENTER","","<B>ERROR:</B> Your '<I>Oth. Inv. 2</I>' and '<I>Oth. Inv. 3</I>'");
	fy_winprn("CENTER","","cannot be the same!!!");
	$ef=1;
}


# If the coast it clear, then let's enter some data!!!
if (!$ef)
{
	fy_winprn("CENTER","","Entering Data into Database...");

	# Look up the names of the user, resident, & staff...
	$temp=fy_conloginidlookup($conn,$cookie_id,$fydb_type,$fydb_name);
	$temp2=fy_conidlookup($conn,$gr_resident,$fydb_type,$fydb_name);
	$temp3=fy_conidlookup($conn,$gr_staff,$fydb_type,$fydb_name);
	$temp5=date("m/d/Y");
	$temp6=date("H:i");
	$temp7=fy_putdate($fydb_type, $gr_incidentdate_m, $gr_incidentdate_d, $gr_incidentdate_y);
	$temp8=fy_putdate($fydb_type, date("m"), date("d"), date("Y"));
	

	# Insert the fy_ir data elements
	# Form the SQL statement & execute
	$sql = "INSERT INTO fy_ir (incident_date, incident_time, incident_time_end, date_reported, time_reported, resident, resident_id, staff, staff_id, group_home, at_group_home, incident_address, written_by, written_by_id, critical) VALUES ('$temp7','$gr_incidenttime_h:$gr_incidenttime_m','$gr_incidenttime_e_h:$gr_incidenttime_e_m','$temp8','$temp6','$temp2','$gr_resident','$temp3','$gr_staff','$gr_grouphome','$gr_atgrouphome','$gr_incidentaddress', '$temp','$cookie_id','$gr_critical')";
	$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);

	# OK.  What we are about to do is sort of a problem for multi-database
	# system.  I want to go back and get the assigned ID that was given to
	# the last inserted row.  The problem is, this is different accross
	# databases (in PHP).  So, unfortunately, we have to take care of that
	# here in this script file, and not in the freemed_yirc-funcs.inc file.
	# ----
	# If the database type is 'psql', then we need to back to that
	# OID and get the ID.
	if ($fydb_type == "psql")
	{
		$lastoid= pg_getlastoid($result_set);
		# Get the ID assigned to the last inserted record
		# Form the SQL statement, execute it, and get the result
		$sql = "SELECT * FROM fy_ir WHERE oid = $lastoid";
		$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);
		$id=fy_getfield($fydb_type, $result_set, 0, "id");
	} elseif ($fydb_type == "mysql") {
		# PHP has a simple function to get the last ID for MySQL
		# since our fy_getlastid function already got it, we're
		# pretty much done for MySQL!
		$id=mysql_insert_id($result_set);
	}

	# Insert the fy_ir_sum data elements
	# Form the SQL statement & execute
	$sql = "INSERT INTO fy_ir_sum (FID, remarks_summary, action_taken, other_remarks) VALUES ('$id','$gr_remarkssummary','$gr_actiontaken','$gr_otherremarks')";
	$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);
	
	# Insert the fy_ir_cat data elements
	# Form the SQL statement & execute
	$sql = "INSERT INTO fy_ir_cat (FID, needed_pci, temper_tantrum, stealing, property_damage, injury_self, injury_other, fighting, drug, alcohol, awol, car_wo_permission, verbal_abuse, other, cir) VALUES ('$id','$gr_neededpci','$gr_tempertantrum','$gr_stealing','$gr_propertydamage','$gr_injuryself','$gr_injuryother','$gr_fighting','$gr_drug','$gr_alcohol','$gr_awol','$gr_carwoperm','$gr_verbalabuse','$gr_other','$gr_critical')";
	$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);

	# Insert the fy_ir_tt data elements
	# Form the SQL statement & execute
	$sql = "INSERT INTO fy_ir_tt (FID, pre_tantrum_anxiety, inter_personal_conflict, either_or_stage, defiant_stage, aggression_to_depression, post_tantrum_stage, staff_supportive, staff_directive, staff_maintains, helped_resident, staff_intervention, staff_taught_stages, tt_other) VALUES ('$id','$gr_pretantrum','$gr_interpersonal','$gr_eitheror','$gr_defiantstage','$gr_aggression','$gr_posttantrum','$gr_staffsupportive','$gr_staffdirective','$gr_staffmaint','$gr_helpedres','$gr_staffintervention','$gr_stafftaught','$gr_ttother')";
	$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);

	# Insert the fy_ir_pci data elements
	# Form the SQL statement & execute
	$gr_lor = trim($gr_lor);
	$gr_defensivelevel = trim($gr_defensivelevel);
	$sql = "INSERT INTO fy_ir_pci (FID, anxiety_stage, youth_defensive, defensive_level, aop, tension_reduction, length_of_restraint, pci_other) VALUES ('$id','$gr_anxietystage','$gr_youthdef',$gr_defensivelevel,'$gr_aop','$gr_tension',$gr_lor,'$gr_pciother')";
	$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);

	# Insert the fy_ir_othinv data elements
	# Form the SQL statement & execute
	if ($gr_othinv1_ok == "X")
	{
		$oth1=",othinv1";
		$oth1_id=",othinv1_id";
		$temp_oth1=",'".fy_conidlookup($conn,$gr_othinv1,$fydb_type,$fydb_name)."'";
		$temp_oth1_id=",'".$gr_othinv1."'";
	} else {
		$oth1="";
		$oth1_id="";
		$temp_oth1="";
		$temp_oth1_id="";
	}
	if ($gr_othinv2_ok == "X")
	{
		$oth2=",othinv2";
		$oth2_id=",othinv2_id";
		$temp_oth2=",'".fy_conidlookup($conn,$gr_othinv2,$fydb_type,$fydb_name)."'";
		$temp_oth2_id=",'".$gr_othinv2."'";
	} else {
		$oth2="";
		$oth2_id="";
		$temp_oth2="";
		$temp_oth2_id="";
	}
	if ($gr_othinv3_ok == "X")
	{
		$oth3=",othinv3";
		$oth3_id=",othinv3_id";
		$temp_oth3=",'".fy_conidlookup($conn,$gr_othinv3,$fydb_type,$fydb_name)."'";
		$temp_oth3_id=",'".$gr_othinv3."'";
	} else {
		$oth3="";
		$oth3_id="";
		$temp_oth3="";
		$temp_oth3_id="";
	}
	$sql = "INSERT INTO fy_ir_othinv (FID $oth1 $oth1_id $oth2 $oth2_id $oth3 $oth3_id) VALUES ('$id'".$temp_oth1.$temp_oth1_id.$temp_oth2.$temp_oth2_id.$temp_oth3.$temp_oth3_id.")";

	$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);

	fy_winprn("CENTER","","<BR><P>");
	fy_winprn("CENTER","","<B>DONE!</B>");
	fy_winback("","ir.php?fy_id=$fy_id");

} else {
	fy_winprn("CENTER","","<BR><P>");
	fy_winprn("CENTER","","<B><BLINK>Please use your browser's <I>back</I> button</BLINK></B>");
	fy_winprn("CENTER","","<B><BLINK>to return to the Incident Report form.</BLINK></B>");
	fy_winprn("CENTER","","<BR><P>");
}

fy_endwindow("User: $cookie_user");
fy_endhtml();

?>
