<?php

include "freemed_yirc-vars.inc";
include "freemed_yirc-funcs.inc";

fy_cookiecheck($cookie_user);
fy_resetcookie($cookie_user, $cookie_id, $fy_cookietime);

# Check out $cookie_id with the secdb.  Make sure 'ir_edit' = 'X'.
$conn=fy_makeconn($fydb_type, $fydb_host, $fydb_user, $fydb_name);
$sql = "SELECT * FROM fy_secdb WHERE loginid = '$cookie_id'";
$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);
$rows=fy_resultrows($fydb_type, $result_set);

if ($rows > 0)
{
	$perm=fy_getfield($fydb_type, $result_set, 0, "ir_edit");
} else {
	$perm = " ";
}

if ($perm != "X")
{
	fy_starthtml("Freemed-Yirc: Error","");
	fy_startwindow();
	fy_winprn("CENTER","","I'm sorry, but you don't have permission to edit the Incident Report database.");
	fy_winback("","main.php");
	fy_endwindow("User: $cookie_user");
	fy_endhtml();
	exit;
}

fy_starthtml("Freemed-Yirc: Verifying Entered Data","");
fy_startwindow();
fy_winprn("CENTER","","Verifying Entered Data...");

# ======= VERIFY USER ENTERED DATA =======

# Reset EXITFLAG
$ef=0;

# Incident Date
if (!checkdate($gr_incidentdate_m, $gr_incidentdate_d, $gr_incidentdate_y))
{
	fy_winprn("CENTER","","<B>ERROR:</B> Invalid Date entered in '<I>Incident Date</I>'");
	$ef=1;
}

# Incident Date/Future....
if (!$ef)
{
	if (fy_isfuture($gr_incidentdate_m,$gr_incidentdate_d,$gr_incidentdate_y))
	{
		fy_winprn("CENTER","","<B>ERROR:</B> Invalid Date entered in '<I>Incident Date</I>'");
		fy_winprn("CENTER","","Date cannot be in the future.");
		$ef=1;
	}
}

# Incident Time (Hour)
if ($gr_incidenttime_h > 12 or $gr_incidenttime_h =="")
{
	fy_winprn("CENTER","","<B>ERROR:</B> Invalid Hour entered in '<I>Incident Time</I>'");
	fy_winprn("CENTER","","Should be 1-12");
	$ef=1;
}
if ($gr_incidenttime_ap == "PM")
{
	$gr_incidenttime_h = $gr_incidenttime_h + 12;
}
if ($gr_incidenttime_ap == "AM" AND $gr_incidenttime_h == "12")
{
	$gr_incidenttime_h = 0;
}

# Incident End Time (Hour)
if ($gr_incidenttime_e_h > 12 or $gr_incidenttime_e_h =="")
{
	fy_winprn("CENTER","","<B>ERROR:</B> Invalid Hour entered in '<I>Incident End Time</I>'");
	fy_winprn("CENTER","","Should be 1-12");
	$ef=1;
}
if ($gr_incidenttime_e_ap == "PM")
{
	$gr_incidenttime_e_h = $gr_incidenttime_e_h + 12;
}
if ($gr_incidenttime_e_ap == "AM" AND $gr_incidenttime_e_h == "12")
{
	$gr_incidenttime_e_h = 0;
}

# Incident Time (Minute)
if ($gr_incidenttime_m > 60 or $gr_incidenttime_m =="")
{
	fy_winprn("CENTER","","<B>ERROR:</B> Invalid Minute entered in '<I>Incident Time</I>'");
	fy_winprn("CENTER","","Should be 1-60");
	$ef=1;
}

# Incident End Time (Minute)
if ($gr_incidenttime_e_m > 60 or $gr_incidenttime_e_m =="")
{
	fy_winprn("CENTER","","<B>ERROR:</B> Invalid Minute entered in '<I>Incident End Time</I>'");
	fy_winprn("CENTER","","Should be 1-60");
	$ef=1;
}

# Incident End Time is AFTER Incident Time...
$temp_er=0;
if ($gr_incidenttime_e_ap == $gr_incidenttime_ap)
{
	if ($gr_incidenttime_e_h < $gr_incidenttime_h)
	{
		$temp_er=1;
	}
	if ($gr_incidenttime_e_h == $gr_incidenttime_h)
	{
		if ($gr_incidenttime_e_m < $gr_incidenttime_m)
		{
			$temp_er=1;
		}
	}
}
if ($temp_er == 1)
{
	fy_winprn("CENTER","","<B>ERROR:</B> Invalid Time entered in '<I>Incident End Time</I>'");
	fy_winprn("CENTER","","Should be <I>AFTER</I> Incident Time!");
	$ef=1;
}

# Incident Address
if ($gr_atgrouphome == "X")
{
	$gr_incidentaddress = $gr_grouphome;
} else {
	$gr_incidentaddress = ucwords(strtolower($gr_incidentaddress));
}

if ($gr_tempertantrum == "")
{
	$gr_pretantrum = "";
	$gr_staffsupportive = "";
	$gr_interpersonal = "";
	$gr_staffdirective = "";
	$gr_eitheror = "";
	$gr_staffmaint = "";
	$gr_defiantstage = "";
	$gr_helpedres = "";
	$gr_aggression = "";
	$gr_staffintervention = "";
	$gr_posttantrum = "";
	$gr_stafftaught = "";
	$gr_ttother = "";
}

if ($gr_neededpci == "")
{
	$gr_anxietystage = "";
	$gr_youthdef = "";
	$gr_aop = "";
	$gr_tension = "";
	$gr_pciother = "";
	$gr_defensivelevel = 0;
	$gr_lor = 0;
}

# OTHERS INVOLVED
# We gotta lotta work to do here.  There are many ways to enter 'faulty' 
# data here, and we gotta check for ALL OF EM.
# If othinv1_ok was not checked, then blank out othinv1
if ($gr_othinv1_ok == "") {$gr_othinv1="";}
# If othinv2_ok was not checked, then blank out othinv2
if ($gr_othinv2_ok == "") {$gr_othinv2="";}
# If othinv3_ok was not checked, then blank out othinv3
if ($gr_othinv3_ok == "") {$gr_othinv3="";}
# If othinv1_ok was not specified but othinv2_ok was, then error!
if ($gr_othinv1_ok != "X" AND $gr_othinv2_ok == "X")
{
	fy_winprn("CENTER","","<B>ERROR:</B> You have a second person involved in '<I>Oth. Inv. 2</I>'");
	fy_winprn("CENTER","","But you have no first person involved...");
	$ef=1;
}
# If othinv1_ok was not specified but othinv3_ok was, then error!
if ($gr_othinv1_ok != "X" AND $gr_othinv3_ok == "X")
{
	fy_winprn("CENTER","","<B>ERROR:</B> You have a third person involved in '<I>Oth. Inv. 3</I>'");
	fy_winprn("CENTER","","But you have no first person involved...");
	$ef=1;
}
# If othinv1_ok was specified, othinv2_ok was not, but othinv3_ok was, error!
if ($gr_othinv1_ok == "X" AND $gr_othinv2_ok != "X" AND $gr_othinv3_ok == "X")
{
	fy_winprn("CENTER","","<B>ERROR:</B> You have a third person involved in '<I>Oth. Inv. 3</I>'");
	fy_winprn("CENTER","","But you have no second person involved...");
	$ef=1;
}
# Lets make sure that othinv1 isn't the same as our resident!
if ($gr_resident == $gr_othinv1)
{
	fy_winprn("CENTER","","<B>ERROR:</B> Your '<I>Oth. Inv. 1</I>' cannot be the");
	fy_winprn("CENTER","","same as your resident!!!");
	$ef=1;
}
# Lets make sure that othinv2 isn't the same as our resident!
if ($gr_resident == $gr_othinv2)
{
	fy_winprn("CENTER","","<B>ERROR:</B> Your '<I>Oth. Inv. 2</I>' cannot be the");
	fy_winprn("CENTER","","same as your resident!!!");
	$ef=1;
}
# Lets make sure that othinv3 isn't the same as our resident!
if ($gr_resident == $gr_othinv3)
{
	fy_winprn("CENTER","","<B>ERROR:</B> Your '<I>Oth. Inv. 3</I>' cannot be the");
	fy_winprn("CENTER","","same as your resident!!!");
	$ef=1;
}
# Lets make sure that othinv1 isn't the same as othinv2!!!
if (($gr_othinv1 == $gr_othinv2) AND ($gr_othinv1 != ""))
{
	fy_winprn("CENTER","","<B>ERROR:</B> Your '<I>Oth. Inv. 1</I>' and '<I>Oth. Inv. 2</I>'");
	fy_winprn("CENTER","","cannot be the same!!!");
	$ef=1;
}
# Lets make sure that othinv1 isn't the same as othinv3!!!
if ($gr_othinv1 == $gr_othinv3 AND ($gr_othinv3 != ""))
{
	fy_winprn("CENTER","","<B>ERROR:</B> Your '<I>Oth. Inv. 1</I>' and '<I>Oth. Inv. 3</I>'");
	fy_winprn("CENTER","","cannot be the same!!!");
	$ef=1;
}
# Lets make sure that othinv2 isn't the same as othinv3!!!
if ($gr_othinv2 == $gr_othinv3 AND ($gr_othinv2 != ""))
{
	fy_winprn("CENTER","","<B>ERROR:</B> Your '<I>Oth. Inv. 2</I>' and '<I>Oth. Inv. 3</I>'");
	fy_winprn("CENTER","","cannot be the same!!!");
	$ef=1;
}

# If the coast is clear, update the records!
if (!$ef)
{
	fy_winprn("CENTER","","Updating Database Record...");

	# Look up the names of the user, resident, & staff...
	$temp=fy_conloginidlookup($conn,$cookie_id, $fydb_type, $fydb_name);
	$temp2=fy_conidlookup($conn,$gr_resident, $fydb_type, $fydb_name);
	$temp3=fy_conidlookup($conn,$gr_staff, $fydb_type, $fydb_name);
	$temp7=fy_putdate($fydb_type, $gr_incidentdate_m, $gr_incidentdate_d, $gr_incidentdate_y);

	# Update the fy_ir data elements
	# Form the SQL statement & execute
	$sql = "UPDATE fy_ir SET incident_date='$temp7', incident_time='$gr_incidenttime_h:$gr_incidenttime_m', incident_time_end='$gr_incidenttime_e_h:$gr_incidenttime_e_m', resident='$temp2', resident_id='$gr_resident', staff='$temp3', staff_id='$gr_staff', group_home='$gr_grouphome', at_group_home='$gr_atgrouphome', incident_address='$gr_incidentaddress', critical='$gr_critical' WHERE id='$fy_id'";
	$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);

	# Update the fy_ir_sum data elements
	# Form the SQL statement & execute
	$sql = "UPDATE fy_ir_sum SET remarks_summary='$gr_remarkssummary', action_taken='$gr_actiontaken', other_remarks='$gr_otherremarks'";
	$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);
	
	# Update the fy_ir_cat data elements
	# Form the SQL statement & execute
	$sql = "UPDATE fy_ir_cat SET needed_pci='$gr_neededpci', temper_tantrum='$gr_tempertantrum', stealing='$gr_stealing', property_damage='$gr_propertydamage', injury_self='$gr_injuryself', injury_other='$gr_injuryother', fighting='$gr_fighting', drug='$gr_drug', alcohol='$gr_alcohol', awol='$gr_awol', car_wo_permission='$gr_carwoperm', verbal_abuse='$gr_verbalabuse', other='$gr_other', cir='$gr_critical' WHERE id='$fy_id'";
	$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);

	# Update the fy_ir_tt data elements
	# Form the SQL statement & execute
	$sql = "UPDATE fy_ir_tt SET pre_tantrum_anxiety='$gr_pretantrum', inter_personal_conflict='$gr_interpersonal', either_or_stage='$gr_eitheror', defiant_stage='$gr_defiantstage', aggression_to_depression='$gr_aggression', post_tantrum_stage='$gr_posttantrum', staff_supportive='$gr_staffsupportive', staff_directive='$gr_staffdirective', staff_maintains='$gr_staffmaint', helped_resident='$gr_helpedres', staff_intervention='$gr_staffintervention', staff_taught_stages='$gr_stafftaught', tt_other='$gr_ttother' WHERE id='$fy_id'";
	$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);

	# Update the fy_ir_pci data elements
	# Form the SQL statement & execute
	$gr_lor = trim($gr_lor);
	$gr_defensivelevel = trim($gr_defensivelevel);
	if ($gr_youthdef != "X") {$gr_defensivelevel=0;}
	$sql = "UPDATE fy_ir_pci SET anxiety_stage='$gr_anxietystage', youth_defensive='$gr_youthdef', defensive_level='$gr_defensivelevel', aop='$gr_aop', tension_reduction='$gr_tension', length_of_restraint='$gr_lor', pci_other='$gr_pciother' WHERE id='$fy_id'";
	$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);

	# Update the fy_ir_othinv data elements
	# Form the SQL statement & execute
	if ($gr_othinv1_ok == "X")
	{
		$temp_oth1=fy_conidlookup($conn,$gr_othinv1,$fydb_type,$fydb_name);
		$temp_oth1_id=$gr_othinv1;
		$temp_oth1=",othinv1='".$temp_oth1."',othinv1_id='".$temp_oth1_id."'";
	} else {
		$temp_oth1=",othinv1=NULL,othinv1_id=NULL";
	}
	if ($gr_othinv2_ok == "X")
	{
		$temp_oth2=fy_conidlookup($conn,$gr_othinv2,$fydb_type,$fydb_name);
		$temp_oth2_id=$gr_othinv2;
		$temp_oth2=",othinv2='".$temp_oth2."',othinv2_id='".$temp_oth2_id."'";
	} else {
		$temp_oth2=",othinv2=NULL,othinv2_id=NULL";
	}
	if ($gr_othinv3_ok == "X")
	{
		$temp_oth3=fy_conidlookup($conn,$gr_othinv3,$fydb_type,$fydb_name);
		$temp_oth3_id=$gr_othinv3;
		$temp_oth3=",othinv3='".$temp_oth3."',othinv3_id='".$temp_oth3_id."'";
	} else {
		$temp_oth3=",othinv3=NULL,othinv3_id=NULL";
	}

	$sql = "UPDATE fy_ir_othinv SET fid='$fy_id' $temp_oth1 $temp_oth2 $temp_oth3 WHERE fid='$fy_id'";
	$result_set=fy_execsql($fydb_type, $fydb_name, $conn, $sql);

	fy_winprn("CENTER","","<BR><P>");
	fy_winprn("CENTER","","<B>DONE!</B>");
	fy_winback("","ir.php?fy_id=$fy_gh");

} else {
	fy_winprn("CENTER","","<BR><P>");
	fy_winprn("CENTER","","<BLINK><B>Please use your browser's <I>back</I> button</B></BLINK>");
	fy_winprn("CENTER","","<BLINK><B>to return to the Incident Report form.</B></BLINK>");
	fy_winprn("CENTER","","<BR><P>");
}

fy_endwindow("User: $cookie_user");
fy_endhtml();

?>
